#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "mpsapi.h"
#include "usclasses.h"
#include "usstr.h"
#include "plugin-common.h"  
//
//
//	  
//	      
//
OpcMP_status_t PLUGIN_CLOSE(OpcMP_plugin_t * plugin)
{
	//   
	my_plugin_data * data = (my_plugin_data*)mps_getPluginData(plugin);
	// 

	//     
	int NumberTags = mps_getPluginNumberTags(plugin);

	//    
	for (int i = 0; i < NumberTags; i++)
	{
		//     
		OpcMP_tag_t *opcmp_tag = (OpcMP_tag_t *)mps_getPluginTag(plugin, i);
		//   
		my_tagdata * tagdata = (my_tagdata *)mps_getTagData(opcmp_tag);
		if (tagdata != NULL)
		{
			if (tagdata->TypeChannel != NULL)
				mps_free(plugin, (void *)tagdata->TypeChannel);
			mps_free(plugin, (void *)tagdata);
		}
	}
	return OPCMP_SUCCESS;
}
