#ifdef _WIN32
//#include <windows.h>
//#include <Winsock2.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
//#include "config.h"
#include "mpsapi.h"
#include "usclasses.h"
#include "usstr.h"
#include "plugin-common.h"
//
//   
//      
//
OpcMP_status_t PLUGIN_WRITE(OpcMP_plugin_t * plugin)
{
	OpcMP_status_t status = OPCMP_SUCCESS;
	char errbuf[1024];
	char rb[80];
	// get plugin specific data 
	USList *readvar = NULL;

	//   
	mps_DebugMessage(plugin, "plugin :write");

	//   
	my_plugin_data * data = (my_plugin_data*)mps_getPluginData(plugin);

	//        
	int NumberTags = mps_getPluginNumberWriteTags(plugin);
	readvar = new USList();
	for (int i = 0; i < NumberTags; i++)
	{
		const char * varname = NULL;

		//    
		OpcMP_tag_t *opcmp_tag = (OpcMP_tag_t *)mps_getPluginWriteTag(plugin, i);
		//    
		my_tagdata * mytagdata = (my_tagdata *)mps_getTagData(opcmp_tag);
		if (mytagdata == NULL)
		{
			continue;
		}
		readvar->add(opcmp_tag);
	}
	//   
	bool result = WriteDevice(plugin, readvar);
	//   
	if (readvar->count() != 0)
	{
		//status = simulate(plugin,readvar);
		readvar->clear();
	}
	mps_free(plugin,(void *)readvar);
	// 
	return status;
};
