#include <stdio.h>
#include <stdlib.h>
#include <time.h>
//#include "config.h"
#include "usclasses.h"
#include "usfunc.h"
#include "mpsapi.h"
#include "plugin-common.h"
/* METHOD BODY */
OpcMP_status_t PLUGIN_INIT( OpcMP_plugin_t * plugin )
{
	// get plugin specific data 
	int maxoids;
	const char *tmp;
	char errbuf[256];
    mps_mutex_lock(plugin);
	mps_DebugMessage(plugin,"tcpserverecho :init");
	my_plugin_data * data = (my_plugin_data * )mps_malloc(plugin,sizeof( my_plugin_data ) );
	memset(data,0,sizeof( my_plugin_data ));
	mps_setPluginData(plugin,(void *)data);
	int NumberTags = mps_getPluginNumberTags(plugin);
	for (int i = 0; i<NumberTags; i++)
	{
		my_tagdata *mytagdata;
		mps_Object	*propnode;
		OpcMP_tag_t *tag;
		tag = (OpcMP_tag_t *)mps_getPluginTag(plugin,i);
		mytagdata = (my_tagdata *)mps_malloc(plugin, sizeof(my_tagdata));
		mytagdata->WasChange = false;
		mytagdata->Count     = 0;
		mytagdata->String	 = new USString;
		mps_setTagData(tag, mytagdata);
	}
    // initialize random engine 
    mps_mutex_unlock(plugin);
	return OPCMP_SUCCESS;

}
