#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include "mpsapi.h" 
#include "plugin-common.h" 
static char                BufferFrom[80];
static char                BufferTo[40];
static int                 LenTo = 5;
static int                 LenFrom = 5;
static unsigned char       DOBUFFER[256];
static unsigned short int  d7000[256];
static unsigned short int  d7000o[256];
//
unsigned   itoahex(unsigned, char *);
void       SetAddress(int, char *);
void       Initialize(int);
char HexToAscii(int hex)
{
	if (hex < 10)return((char)(hex + '0'));
	else return((char)(hex - 10 + 'A'));
}
//
int AsciiToHex(char data)
{
	if (data >= '0' && data <= '9') return data - '0';
	if (data >= 'A' && data <= 'F') return data - 'A' + 10;
	if (data >= 'a' && data <= 'f') return data - 'a' + 10;
	return 0;
}

//
static int ReceiveResponseFrom7000_3(int Port, char *cCmd, long SizeIn, int iChksum)
{
}
int GetB(int port, unsigned long TimeOut)
{
	int C = 0;
	return C;
}

static int BlockToRs(int port, char *SourceBuffer, int SourceLen, char *DestBuffer)
{
	return 1;
};

void Read7017(OpcMP_plugin_t *Plugin, struct Zapros *Zpr, int ttyp, int NChannel);
void ReadDigitalAll(OpcMP_plugin_t *Plugin, struct Zapros  *Zpr, unsigned short int ttyp);
void WriteDigitalAll(OpcMP_plugin_t *Plugin, struct Zapros *Zpr, unsigned short int ttyp);
void ReadWriteDigitalAll(OpcMP_plugin_t *Plugin, struct Zapros *Zpr, unsigned short int ttyp);
void SetConfig(void *Cfg)
{
	int i;
	for (i = 0; i < 256; i++)
	{
		d7000[i] = 0;
		d7000o[i] = 0;
	};
};
int SendSwitchChannel(OpcMP_plugin_t *Plugin, struct Zapros *Zpr)
{
	float Value;
	int Rez, To;
	BufferTo[0] = '$';
	To = 5;
	BufferTo[3] = '3';
	BufferTo[4] = Zpr->Channel + 0x30;
	BufferTo[4] = 0x0d;
	BufferTo[5] = 0x00;
	Rez = SendBlockToRs(Plugin, Zpr->Gaddress,
		BufferTo, To,
		BufferFrom, 5,
		3,Zpr->ksum);
	if (Rez < 0)
		return  -1;
	if (BufferFrom[0] != '!')
	{
		return  -1;
	};
	if ((Zpr->Channel + 0x30) == BufferFrom[3])
		return 2;
	To = 6;
	BufferTo[3] = '3';
	BufferTo[4] = Zpr->Channel + 0x30;
	BufferTo[5] = 0x0d;
	BufferTo[6] = 0x00;
	Rez = SendBlockToRs(Plugin, Zpr->Gaddress,
		BufferTo, To,
		BufferFrom, 4,
		3,Zpr->ksum);
	if (Rez < 0)
		return  -1;
	if (BufferFrom[0] != '!')
	{
		return  -1;
	};
	return 2;
};

int SendAnalog(OpcMP_plugin_t *Plugin, struct Zapros *Zpr, float range, int N, float range1)
{
	float Value;
	int Rez, To;
	BufferTo[0] = '#';
	if (N != 0)
	{
		To = 5;
		BufferTo[3] = Zpr->Channel + 0x30;
		BufferTo[4] = 0x0d;
		BufferTo[5] = 0x00;
	}
	else
	{
		To = 4;
		BufferTo[3] = 0x0d;
		BufferTo[4] = 0x00;

	};
	Rez = SendBlockToRs(Plugin, Zpr->Gaddress,
		BufferTo, To,
		BufferFrom, 9,
		3,Zpr->ksum);
	if (Rez < 0)
		return  -1;
	if (BufferFrom[0] != '>')
	{
		return  -1;
	};
	Value = atof(&BufferFrom[1]);
	*(unsigned long  *)&Zpr->Buffer[0] = *(unsigned long *)&Value;
	return 2;
};
void ReadCI(OpcMP_plugin_t *Plugin, struct Zapros *Zpr)
{
	unsigned short int Value;
	int Rez, To;
	BufferTo[0] = '#';
	To = 5;
	BufferTo[3] = Zpr->Channel + 0x30;
	BufferTo[4] = 0x0d;
	BufferTo[5] = 0x00;
	Rez = SendBlockToRs(Plugin, Zpr->Gaddress,
		BufferTo, To,
		BufferFrom, 9,
		3,Zpr->ksum);
	if (Rez < 0)
	{
		Zpr->Status = -1;
		return;
	}
	if (BufferFrom[0] != '!')
	{
		Zpr->Status = -1;
		return;
	};
	char Data[6];
	memcpy(Data, &BufferFrom[3], 5);
	Data[5] = 0;
	Value = atol(Data);
	*(unsigned short int  *)&Zpr->Buffer[0] = Value;
	Zpr->Status = 2;
	return;
};

void  Read(OpcMP_plugin_t *Plugin, struct Zapros *Zpr)
{
	float Value, range1;
	unsigned  short int dwVal, QKind;
	char ch, format;
	unsigned char ttyp = 0;
	int Rez, i, j, GlobalTyp;
	long range = 0;
	SetAddress(Zpr->Address, &BufferTo[1]);
	GlobalTyp = Zpr->Status;
	Rez = 2;
	QKind = Zpr->QKind;
	range1 = 0;
	if (QKind != 0)
	{
		switch (Zpr->Typ)
		{
		case 7017:
			Read7017(Plugin, Zpr, ttyp, 8);
			return;
		default:
			break;
		};
	};
	switch (Zpr->Typ)
	{
		// digital input
		//
	case 7041:
	case 7044:
		//
		ReadDigitalAll(Plugin, Zpr, ttyp);
		Rez = Zpr->Status;
		break;
	default:
		Rez = 0;
		break;
	};
ret:
	Zpr->Status = Rez;
	return;
}
void   Write(OpcMP_plugin_t *Plugin, struct Zapros *Zpr)
{
	unsigned short int QKind;
	float fVal, range;
	char val;
	int Rez, i, Off, GlobalTyp;
	float da_val;
	unsigned char ttyp = 0;
	BufferTo[0] = '#';
	SetAddress(Zpr->Address, &BufferTo[1]);
	GlobalTyp = Zpr->Status;
	switch (Zpr->Typ)
	{
	case 7021:
		if (GlobalTyp == 0)   //ANALOG
		{
			Off = 0;
			*(unsigned long *)&da_val = *(unsigned long *)&Zpr->Buffer[0];
			*(unsigned long *)&fVal = *(unsigned long *)&da_val;
			if (ttyp == 0x31)
				fVal += 4;
#define BT BufferTo
#define BF BufferFrom
			BufferTo[5 + Off] = '.';
			BufferTo[9 + Off] = 0x0d;
			BufferTo[10 + Off] = 0;
			if (fVal > 10)
				fVal = 10;
			if (fVal < 0)
				fVal = 0;
			i = (int)(fVal / 10.0);
			BufferTo[3 + Off] = i + 0x30; fVal -= i * 10;
			i = (int)fVal;
			BufferTo[4 + Off] = i + 0x30; fVal -= i;
			fVal *= (float)10.0;
			i = (int)fVal;
			BufferTo[6 + Off] = i + 0x30; fVal -= (float)i;

			fVal *= (float)10.0;
			i = (int)fVal;
			BufferTo[7 + Off] = i + 0x30; fVal -= (float)i;

			fVal *= (float)10.0;
			i = (int)fVal;
			BufferTo[8 + Off] = i + 0x30;
			Rez = SendBlockToRs(Plugin, Zpr->Gaddress,
				BufferTo, 10 + Off,
				BufferFrom, 2,
				3,Zpr->ksum);
		}
		break;
		// DIGIT
	case 7042:
	case 7044:
		//
		QKind = Zpr->QKind;
		if (QKind != 0)
		{
			switch (Zpr->Typ)
			{
			case 7042: //@AADDDD
			case 7044: //#AA00DD
				WriteDigitalAll(Plugin, Zpr, ttyp);
				return; break;
			default:
				break;
			}
		};
		if (*(unsigned short int *)&Zpr->Buffer[0])
			val = '1';
		else               val = '0';
		if (
			(Zpr->Typ == 7042)
			)
		{
			if (Zpr->Channel > 7)
				BufferTo[3] = 'B';
			else
				BufferTo[3] = 'A';
		}
		else
			BufferTo[3] = '1';
		if (Zpr->Channel > 7)
			Zpr->Channel -= 8;

		BufferTo[4] = Zpr->Channel + 0x30;
		BufferTo[5] = '0';  BufferTo[6] = val;
		BufferTo[7] = 0x0d; BufferTo[8] = 0x00;
		Rez = SendBlockToRs(Plugin, Zpr->Gaddress,
			BufferTo, 8,
			BufferFrom, 2,
			3,Zpr->ksum);
		if (Rez <= 0)
			break;
		break;
	default:
		Rez = 0; break;
	}; //end  switch
	Zpr->Status = Rez;
	return;
}
void  ReadWrite(OpcMP_plugin_t *Plugin, struct Zapros *Zpr)
{
	unsigned char ttyp = 0;
	ReadWriteDigitalAll(Plugin, Zpr, ttyp);
}
void SetAddress(int Addr, char *Buff)
{
	if ((Addr >> 4) > 9)     Buff[0] = (char)(Addr >> 4) + 0x37;
	else               Buff[0] = (Addr >> 4) + 0x30;
	if ((Addr & 0x0f) > 9) Buff[1] = (char)(Addr & 0x0f) + 0x37;
	else               Buff[1] = (Addr & 0x0f) + 0x30;
}
float f7000[8];
int	  f7000status[8];
void Read7017(OpcMP_plugin_t *Plugin, struct Zapros *Zpr, int ttyp, int NChannel)
{
	int t, j, i, Rez;
	unsigned short int QKind;
	char cc[10];
	float range, Value, range1;
	QKind = Zpr->QKind;
	if ((Zpr->Channel < 0) || (Zpr->Channel > NChannel))
	{
		Zpr->Status = -1;
		return;
	};
	if (QKind == 1)
	{
		if (f7000status[Zpr->Channel] == -1)
		{
			Zpr->Status = -1;
			return;
		}
	}
	else
	{
		BufferTo[0] = '#';
		BufferTo[3] = 0x0d;
		BufferTo[4] = 0x00;
		Rez = SendBlockToRs(Plugin, Zpr->Gaddress,
			BufferTo, 4,
			BufferFrom, 57,
			3,Zpr->ksum);
		if (Rez < 0)
		{
			for (i = 0; i < 8; i++)
				f7000status[i] = -1;
			Zpr->Status = -1;
			return;
		};
		if (BufferFrom[0] != '>')
		{
			Zpr->Status = -1;
			for (i = 0; i < 8; i++)
				f7000status[i] = -1;
			return;
		};
		t = 1;
		for (j = 0; j < NChannel; j++)
		{
			for (i = 0; i < 7; i++) cc[i] = BufferFrom[i + t];
			f7000[j] = (float)atof(cc);
			f7000status[j] = 1;
			t = t + 7;
		}

	};
	Value = f7000[Zpr->Channel];
NoCalc:
	*(unsigned long *)&Zpr->Buffer[0] = *(unsigned long *)&Value;
	Zpr->Status = 2;
	return;
};
void ReadDigitalAll(OpcMP_plugin_t *Plugin, struct Zapros *Zpr, unsigned short int ttyp)
{
	unsigned short int  Val;
	int Rez;
	unsigned int  wID, mask, wT;
	unsigned int A, B, C, D;
	unsigned short int QKind;
	QKind = Zpr->QKind;
	if ((Zpr->Channel < 0) || (Zpr->Channel > 31))
	{
		Zpr->Status = -1;
		return;
	};

	if (QKind == 1)
	{
		unsigned short int  Val = (d7000[Zpr->Address] >> Zpr->Channel) & 1;
		*(unsigned short int  *)&Zpr->Buffer[0] = Val;
		Zpr->Status = 1;
	}
	else
	{
		switch (Zpr->Typ)
		{
		case 7041: mask = 0x3fff; wID = 0; break; /* DI*16 */
		case 7044: mask = 0x000f; wID = 0; break; /* IO	 */
			//
		default:
			Zpr->Status = -1;
			return;
		}
		BufferTo[0] = '$';
		BufferTo[3] = '6';
		BufferTo[4] = 0x0d;
		BufferTo[5] = 0x00;
		Rez = SendBlockToRs(Plugin, Zpr->Gaddress,
			BufferTo, 5,
			BufferFrom, 8,
			3,Zpr->ksum);
		if (Rez < 0)
		{
			Zpr->Status = -1;
			return;
		};
		if (BufferFrom[0] != '!')
		{
			Zpr->Status = -1;
			return;
		};
		A = AsciiToHex(BufferFrom[1]);
		B = AsciiToHex(BufferFrom[2]);
		C = AsciiToHex(BufferFrom[3]);
		D = AsciiToHex(BufferFrom[4]);
		if (wID == 0) /* 16*DI */
			wT = D + C * 16 + B * 256 + A * 4096;
		else if (wID == 1) /* IO */
			wT = D + C * 16;
		else if (wID == 2) /* 8*DI */
			wT = B + A * 16;
		if (QKind == 2)
		{
			d7000[Zpr->Address] = wT&mask;
			Val = (d7000[Zpr->Address] >> Zpr->Channel) & 1;
		}
		else
		{
			unsigned short int Rab = wT&mask;
			Val = (Rab >> Zpr->Channel) & 1;
		};
		*(unsigned short int *)&Zpr->Buffer[0] = Val;
		Zpr->Status = 1;
	};

}
void WriteDigitalAll(OpcMP_plugin_t *Plugin, struct Zapros *Zpr, unsigned short int ttyp)
{
	unsigned short int  Data, Val;
	unsigned short int T = 1;
	unsigned short int NT;
	int Rez;
	unsigned int wID, mask, wT;
	unsigned int A, B, C, D;
	unsigned short int QKind;
	QKind = Zpr->QKind;
	if ((Zpr->Channel < 0) || (Zpr->Channel > 31))
	{
		Zpr->Status = -1;
		return;
	};
	T = T << Zpr->Channel;
	NT = ~T;
	Data = *(unsigned short int *)&Zpr->Buffer[0];
	if (Data != 0)
		d7000o[Zpr->Address] |= T;
	else
		d7000o[Zpr->Address] &= NT;
	if (QKind == 1)
	{
		Zpr->Status = 1;
		return;
	}
	else
	{
		switch (Zpr->Typ)
		{
		case 7044: //#AA00DD
			wID = 0;
			break;
		case 7042: //@AADDDD
			wID = 1;
			break;
		default:
			Zpr->Status = -1;
			return;
		}
		wT = d7000o[Zpr->Address];
		if (wID == 0) //#AA00DD
		{
			BufferTo[0] = '#';

			B = wT & 0x0f; wT = wT / 16;
			A = wT & 0x0f;
			BufferTo[3] = '0';
			BufferTo[4] = '0';
			BufferTo[5] = HexToAscii(A);
			BufferTo[6] = HexToAscii(B);
			BufferTo[7] = 0x0d;
			BufferTo[8] = 0;
		}
		else if (wID == 1) //@AADDDD
		{
			BufferTo[0] = '@';
			D = wT & 0x0f; wT = wT / 16;
			C = wT & 0x0f; wT = wT / 16;
			B = wT & 0x0f; wT = wT / 16;
			A = wT & 0x0f;

			BufferTo[3] = HexToAscii(A);
			BufferTo[4] = HexToAscii(B);
			BufferTo[5] = HexToAscii(C);
			BufferTo[6] = HexToAscii(D);
			BufferTo[7] = 0x0d;
			BufferTo[8] = 0;
		}
		Rez = SendBlockToRs(Plugin, Zpr->Gaddress,
			BufferTo, 8,
			BufferFrom, 2,
			3,Zpr->ksum);
		if (Rez < 0)
		{
			Zpr->Status = -1;
			return;
		};
		if (BufferFrom[0] != '>')
		{
			Zpr->Status = -1;
			return;
		};
		Zpr->Status = 1;
		return;
	};

}
void ReadWriteDigitalAll(OpcMP_plugin_t *Plugin, struct Zapros *Zpr, unsigned short int ttyp)
{
	unsigned short int  Data, Val;
	unsigned short int T = 1;
	unsigned short int NT;
	int Rez;
	unsigned int wID, mask, wT;
	unsigned int A, B, C, D;
	unsigned short int QKind;
	QKind = Zpr->QKind;
	if ((Zpr->Channel < 0) || (Zpr->Channel > 31))
	{
		Zpr->Status = -1;
		return;
	};
	if (QKind == 1)
	{
		unsigned short int  Val = (d7000o[Zpr->Address] >> Zpr->Channel) & 1;
		*(unsigned short int  *)&Zpr->Buffer[0] = Val;
		Zpr->Status = 1;
	}
	else
	{
		switch (Zpr->Typ)
		{
		case 7044: //#AA00DD
			wID = 0;
			break;
		case 7042: //@AADDDD
			wID = 1;
			break;
		default:
			Zpr->Status = -1;
			return;
		}
		BufferTo[0] = '$';
		BufferTo[3] = '6';
		BufferTo[4] = 0x0d;
		BufferTo[5] = 0x00;
		Rez = SendBlockToRs(Plugin, Zpr->Gaddress,
			BufferTo, 5,
			BufferFrom, 8,
			3,Zpr->ksum);
		if (Rez < 0)
		{
			Zpr->Status = -1;
			return;
		};
		if (BufferFrom[0] != '!')
		{
			Zpr->Status = -1;
			return;
		};
		A = AsciiToHex(BufferFrom[1]);
		B = AsciiToHex(BufferFrom[2]);
		C = AsciiToHex(BufferFrom[3]);
		D = AsciiToHex(BufferFrom[4]);
		if (wID == 1) /* 16*DI */
			wT = D + C * 16 + B * 256 + A * 4096;
		else if (wID == 0) /* 8*DI */
			wT = B + A * 16;
		d7000o[Zpr->Address] = wT;
		unsigned short int  Val = (d7000o[Zpr->Address] >> Zpr->Channel) & 1;
		*(unsigned short int  *)&Zpr->Buffer[0] = Val;
		Zpr->Status = 1;
	}
}

