#ifndef _PLUGINCOMMON_H
#define _PLUGINCOMMON_H
#include <vector>
#include <string>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
//#include "mps_Object.h"
#include "usclasses.h"
//#include "usfunc.h"
#include "mpsapi.h"
//#include "usvariant.h"
struct Zapros
 {
  unsigned short int Gaddress;
  unsigned short int Address;
  unsigned long      Typ;
  unsigned short int Channel;
  unsigned short int QKind;
           short int Status;
		   short int ksum;
  char Buffer[80];
 };
typedef struct 
{
    const char * TypeChannel;
	unsigned int NumberChannel;
} my_tagdata;

typedef struct {
    OpcMP_UInt32    typedevice;
	OpcMP_String ID;
	OpcMP_tag_t *tagPoll;
	OpcMP_tag_t *tagFailure;
	USList *tags;
} my_device_data;

typedef struct {
	OpcMP_UInt32 address;
	OpcMP_Boolean csum;
	OpcMP_plugin_t *deviceplugin;
	OpcMP_String ID;
	OpcMP_tag_t *tagPoll;
	OpcMP_tag_t *tagFailure;
	OpcMP_tag_t *tagDeviceFailure;
	OpcMP_Boolean   FirstRun;
	USList *tags;
} my_subdevice_data;
OpcMP_Int32 SendBlockToRs(OpcMP_plugin_t *Plugin,int port,char *SourceBuffer,int SourceLen,char *DestBuffer,int DestLen,int TimeOut1,boolean csum);
OpcMP_Void read_one_variable(OpcMP_plugin_t * plugin, struct variable_list * vars, OpcMP_tag_t *OpcMP_tag);
OpcMP_Boolean   simulate(OpcMP_plugin_t * plugin, USList *variables);
OpcMP_Boolean ReadDevice(OpcMP_plugin_t * plugin, USList *readvar);
OpcMP_Boolean ReadSubDevice(OpcMP_plugin_t * plugin,USList *readvar);
OpcMP_Boolean  WriteDevice(OpcMP_plugin_t * plugin, USList *writevar);
OpcMP_Boolean  WriteSubDevice(OpcMP_plugin_t * plugin, USList *writevar);
OpcMP_Void  Write(OpcMP_plugin_t * Plugin,struct Zapros *Zpr);
OpcMP_Void  Read(OpcMP_plugin_t  * Plugin, struct Zapros *Zpr);
OpcMP_Void  ReadCI(OpcMP_plugin_t *Plugin, struct Zapros *Zpr);
OpcMP_Void  ReadWrite(OpcMP_plugin_t *Plugin, struct Zapros *Zpr);
#endif
