#ifndef _PLUGINCOMMON_H
#define _PLUGINCOMMON_H
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "mpsapi.h"
#include "usclasses.h"
#include "usfunc.h"
typedef struct{
	OpcMP_String SimType;
	OpcMP_Int32 MINSAW;
	OpcMP_Int32 MAXSAW;
	OpcMP_Float DELTASAW;
	OpcMP_Int32 MINANA;
	OpcMP_Int32 MAXANA;
	OpcMP_Float DELTASIN;
	OpcMP_Float SinArg;
	USString OldString;
	OpcMP_Float OldValue;
}my_tagdata;
typedef struct{
	OpcMP_String NameDevice;
}my_devicedata;
void read_one_variable(OpcMP_plugin_t * plugin,struct variable_list * vars,OpcMP_tag_t *tag);
OpcMP_status_t  simulate(OpcMP_plugin_t * plugin,USList *variables);
bool WriteTagToHDA(OpcMP_plugin_t *Plugin,OpcMP_tag_t *Tag);
#endif
