#include <stdio.h>
#include <stdlib.h>
#include <time.h>
//#include "config.h"
#include "usclasses.h"
#include "usfunc.h"
#include "mpsapi.h"
#include "plugin-common.h" 
OpcMP_status_t PLUGIN_READ( OpcMP_plugin_t * plugin )
{
	OpcMP_status_t status = OPCMP_SUCCESS;
	char errbuf[1024];
	char rb[80];
	// get plugin specific data 
	USList *readvar = NULL;
	mps_DebugMessage(plugin,"plugin :read");
 	my_plugin_data * data = (my_plugin_data*)mps_getPluginData( plugin );
	readvar = new USList();
	int NumberTags = mps_getPluginNumberReadTags(plugin);
	for(int i=0;i < NumberTags;i++) 
	{
      OpcMP_tag_t *tag = mps_getPluginReadTag(plugin,i);
	  my_tagdata * mytagdata = (my_tagdata *)mps_getTagData(tag);
	  if(mytagdata == NULL)
	  {
	    mps_setTagQwality(tag,OPCMP_QUALITY_BAD);
		continue;
	  }
	  if (mytagdata->WasChange){
		  mytagdata->WasChange = false;
		  if (i==0)
			  mps_setTagAsString(tag,(char *)mytagdata->String->getChars());
		  if (i==1)
			  mps_setTagAsUInt(tag, mytagdata->Count);
	  }
	}
	return status;
};
